# Class JmolGenericPopup

java.lang.Object
org.jmol.popup.GenericPopup
org.jmol.popup.JmolGenericPopup

All Implemented Interfaces:
  `GenericMenuInterface`

Direct Known Subclasses:
  `JmolPopup, ModelKitPopup`

public abstract class JmolGenericPopup extends GenericPopup
An abstract popup class that is instantiated for a given platform and context as one of:

    -- abstract JmolGenericPopup
      -- abstract JmolPopup
         -- AwtJmolPopup
         -- JSJmolPopup
      -- abstract ModelKitPopup
         -- AwtModelKitPopup
         -- JSModelKitPopup

## Field Summary

Fields
Modifier and Type
Field
Description
`protected SC`
`frankPopup`
`protected Properties`
`menuText`
`protected int`
`nFrankList`
`Viewer`
`vwr`

### Fields inherited from class GenericPopup

`allowSignedFeatures, buttonGroup, currentMenuItemId, helper, htCheckbox, htMenus, isApplet, isJS, isSigned, isTainted, isWebGL, menuName, popupMenu, strMenuStructure, thisPopup, thisx, thisy, updatingForShow`

## Constructor Summary

Constructors
Constructor
Description
`JmolGenericPopup()`

## Method Summary

Modifier and Type
Method
Description
`protected String`
`appFixLabel(String label)`
`protected boolean`
`appGetBooleanProperty(String name)`
`protected void`
`appRestorePopupMenu()`
`protected void`
`appRunScript(String script)`
`protected boolean`
`appRunSpecialCheckBox(SC item, String basename, String script, boolean TF)`
`protected abstract PopupResource`
`getBundle(String menu)`
`protected void`
`initialize(Viewer vwr, PopupResource bundle, String title)`
`void`
`jpiDispose()`
`SC`
`jpiGetMenuAsObject()`
`void`
`jpiInitialize(PlatformViewer vwr, String menu)`
`void`
`jpiShow(int x, int y)`
`protected boolean`
`showFrankMenu()`

### Methods inherited from class GenericPopup

`addMenu, addMenuItem, addMenuItems, appCheckItem, appCheckSpecialMenu, appGetMenuAsString, appUpdateForShow, appUpdateSpecialCheckBoxValue, convertToMegabytes, doMenuCheckBoxCallback, doMenuClickCallback, getEntryIcon, getImageIcon, getScriptForCallback, getUnknownCheckBoxScriptToRun, initSwing, jpiGetMenuAsString, menuAddSeparator, menuAddSubMenu, menuCheckBoxCallback, menuClickCallback, menuCreateCheckboxItem, menuCreateItem, menuEnable, menuFocusCallback, menuGetId, menuGetListPosition, menuNewSubMenu, menuRemoveAll, menuSetAutoscrolls, menuSetLabel, menuShowPopup, setText, show, updateButton, updateSignedAppletItems`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface GenericMenuInterface

`jpiUpdateComputedMenus`

## Field Details

### frankPopup

protected SC frankPopup

### nFrankList

protected int nFrankList

### vwr

public Viewer vwr

### menuText

protected Properties menuText

## Constructor Details

### JmolGenericPopup

public JmolGenericPopup()

## Method Details

### jpiInitialize

public void jpiInitialize(PlatformViewer vwr, String menu)

### getBundle

protected abstract PopupResource getBundle(String menu)

### initialize

protected void initialize(Viewer vwr, PopupResource bundle, String title)

### jpiShow

public void jpiShow(int x, int y)

### showFrankMenu

protected boolean showFrankMenu()

### jpiDispose

public void jpiDispose()

Specified by:
  `jpiDispose` in interface `GenericMenuInterface`
Overrides:
  `jpiDispose` in class `GenericPopup`

### jpiGetMenuAsObject

public SC jpiGetMenuAsObject()

### appFixLabel

protected String appFixLabel(String label)

Specified by:
  `appFixLabel` in class `GenericPopup`

### appGetBooleanProperty

protected boolean appGetBooleanProperty(String name)

Specified by:
  `appGetBooleanProperty` in class `GenericPopup`

### appRunSpecialCheckBox

protected boolean appRunSpecialCheckBox(SC item, String basename, String script, boolean TF)

Specified by:
  `appRunSpecialCheckBox` in class `GenericPopup`

### appRestorePopupMenu

protected void appRestorePopupMenu()

Specified by:
  `appRestorePopupMenu` in class `GenericPopup`

### appRunScript

protected void appRunScript(String script)

Specified by:
  `appRunScript` in class `GenericPopup`